import .connectives
import .leibniz
import .logic
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.le_n : forall (n:nat.nat) , (((nat.le_) ) (n)) (n).
axiom nat.le_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (n)) (((nat.S) ) (m)).
axiom nat.le_ind : forall (n:nat.nat) , forall (Q:(nat.nat) -> Prop) , ((Q) (n)) -> (forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((Q) (m)) -> (Q) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (Q) (m).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
axiom nat.axiom_plus_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))).
theorem nat.eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.axiom_plus_body_S) (n)).
theorem nat.sym_eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) (((nat.plus_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.eq_plus_body_S) (n)).
theorem nat.plus_n_O : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((((nat.plus) ) (n)) ((nat.O) )) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((logic.eq_) (nat.nat)) (_x_365)) ((((nat.plus) ) (_x_365)) ((nat.O) )))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((@logic.refl_) (nat.nat)) ((nat.O) )))))) (fun (x_366 : nat.nat) , fun (_x_368 : (((logic.eq_) (nat.nat)) (x_366)) ((((nat.plus) ) (x_366)) ((nat.O) ))) , ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) (x_366)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) (((nat.S) ) (__)))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (x_366)))) ((((nat.plus) ) (x_366)) ((nat.O) ))) (_x_368))))))) (n).
theorem nat.plus_n_Sm : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((((nat.plus) ) (n)) (((nat.S) ) (m))) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (_x_365)) (m)))) ((((nat.plus) ) (_x_365)) (((nat.S) ) (m))))) (fun (m : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (m))) ((y) (((nat.S) ) (m))))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (m)))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) , (fun (m : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((nat.S) ) ((((nat.plus) ) (x_366)) (m))))) ((y) (((nat.S) ) (m))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (__))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m)))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((_x_368) (m))))))))))) (n).
theorem nat.commutative_plus : ((relations.commutative) (nat.nat)) ((nat.plus) ) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (_x_365)) (y))) ((((nat.plus) ) (y)) (_x_365)))) (fun (y : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((@nat.sym_eq_plus_body_O) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) (y)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (y)) (__))) (((@logic.refl_) (nat.nat)) (y))) ((((nat.plus) ) (y)) ((nat.O) ))) ((@nat.plus_n_O) (y))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (y))) ((((nat.plus) ) (y)) (x_366))) , (fun (y : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (y)) (x_366))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((@nat.plus_n_Sm) (y)) (x_366))) ((((nat.plus) ) (x_366)) (y))) ((_x_368) (y)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((@nat.plus_n_Sm) (x_366)) (y))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (((@nat.plus_n_Sm) (x_366)) (y)))))))) (n).
theorem nat.le_S_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (((((((@nat.le_ind) (n)) (fun (x_417 : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (x_417)))) ((@nat.le_n) (((nat.S) ) (n)))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (n)) (m0)) , (fun (_x_421 : (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m0))) , ((((@nat.le_S) (((nat.S) ) (n))) (((nat.S) ) (m0))) (_x_421))))) (m)) (lenm)).
theorem nat.monotonic_le_plus_r : forall (n:nat.nat) , (((relations.monotonic) (nat.nat)) ((nat.le_) )) (fun (m : nat.nat) , (((nat.plus) ) (n)) (m)) := fun (n : nat.nat) , fun (a : nat.nat) , fun (b : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) (_x_365)) (a))) ((((nat.plus) ) (_x_365)) (b)))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) ((nat.O) )) (a))) ((y) (b)))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (b)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (b)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus_body) ) ((nat.O) )) (a))) ((y) (b)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus_body) ) ((nat.O) )) (a))) ((y) (b)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (b))) (fun (auto : (((nat.le_) ) (a)) (b)) , (auto))))))))) (fun (m : nat.nat) , fun (H : ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) (m)) (a))) ((((nat.plus) ) (m)) (b))) , (fun (leab : (((nat.le_) ) (a)) (b)) , ((((@nat.sym_eq_plus) (((nat.S) ) (m))) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus) (((nat.S) ) (m))) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (m))) (b)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (m))) (b)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus_body) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus_body_S) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus_body) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus_body_S) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((nat.S) ) ((((nat.plus) ) (m)) (b))))) ((((@nat.le_S_S) ((((nat.plus) ) (m)) (a))) ((((nat.plus) ) (m)) (b))) ((H) (leab)))))))))))) (n).
theorem nat.monotonic_le_plus_l : forall (m:nat.nat) , (((relations.monotonic) (nat.nat)) ((nat.le_) )) (fun (n : nat.nat) , (((nat.plus) ) (n)) (m)) := fun (m : nat.nat) , fun (x : nat.nat) , fun (y : nat.nat) , fun (auto : (((nat.le_) ) (x)) (y)) , (((((@logic.eq_coerc) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) ((((nat.plus) ) (x)) (m))) ((((nat.plus) ) (y)) (m)))) (((((@nat.monotonic_le_plus_r) (m)) (x)) (y)) (auto))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (x))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) (__)) ((((nat.plus) ) (y)) (m))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (y))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) (__)))) (((@logic.refl_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y))))) ((((nat.plus) ) (y)) (m))) (((@nat.commutative_plus) (y)) (m)))) ((((nat.plus) ) (x)) (m))) (((@nat.commutative_plus) (x)) (m)))).
